From 77da1c772f8f0b6200611e794bb07f29b4094201 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jan 21 2016 16:11:43 +0000
Subject: [PATCH 251/1001] Some initial tests for should_invalidate


---

diff --git a/hubs/tests/test_widgets/__init__.py b/hubs/tests/test_widgets/__init__.py
index dcf90f9..8b732c3 100644
--- a/hubs/tests/test_widgets/__init__.py
+++ b/hubs/tests/test_widgets/__init__.py
@@ -1,6 +1,7 @@
 from os.path import dirname
 import unittest
 
+import requests
 import vcr
 
 import hubs.models
@@ -31,7 +32,6 @@ class WidgetTest(unittest.TestCase):
         self.vcr.__exit__()
         self.session.remove()
 
-
     def populate(self):
         for user in ['devyani7', 'dhrish', 'shalini', 'ralph', 'decause']:
             openid = '%s.id.fedoraproject.org' % user
@@ -53,3 +53,11 @@ class WidgetTest(unittest.TestCase):
             if widget.plugin == plugin:
                 return widget
         raise KeyError("No such widget found for %s/%s" % (hubname, plugin))
+
+    @staticmethod
+    def get_fedmsg(idx):
+        url = 'https://apps.fedoraproject.org/datagrepper/id'
+        response = requests.get(url, params=dict(id=idx))
+        if not bool(response):
+            raise IOError("Failed to talk to %r %r" % (response.url, response))
+        return response.json()
diff --git a/hubs/tests/test_widgets/test_badges.py b/hubs/tests/test_widgets/test_badges.py
index 9005b2f..4f668b1 100644
--- a/hubs/tests/test_widgets/test_badges.py
+++ b/hubs/tests/test_widgets/test_badges.py
@@ -13,3 +13,24 @@ class TestBadges(hubs.tests.test_widgets.WidgetTest):
         data = json.loads(response.data)
         self.assertEquals(data['plugin'], 'badges')
         assert 'assertions' in data['data'], data['data'].keys()
+
+    def test_should_invalidate_wrong_topic(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        msg = self.get_fedmsg('2016-ebb84660-59e9-4e68-af8f-4e6f49348b88')
+        module = hubs.widgets.registry[widget.plugin]
+        result = module.should_invalidate(msg, self.session, widget)
+        assert not result
+
+    def test_should_invalidate_wrong_user(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        msg = self.get_fedmsg('2016-e371c7f6-bc8e-4632-8e33-b9102dc30b5f')
+        module = hubs.widgets.registry[widget.plugin]
+        result = module.should_invalidate(msg, self.session, widget)
+        assert not result
+
+    def test_should_invalidate_good_match(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        msg = self.get_fedmsg('2016-1fbb1135-681b-4d3b-9a40-d0f6ebd313f4')
+        module = hubs.widgets.registry[widget.plugin]
+        result = module.should_invalidate(msg, self.session, widget)
+        assert result

